// auto-generated DO NOT EDIT

#pragma once

#include <algorithm>
#include <array>
#include <functional>
#include <limits>
#include <mutex>
#include <rclcpp/node.hpp>
#include <rclcpp_lifecycle/lifecycle_node.hpp>
#include <rclcpp/logger.hpp>
#include <set>
#include <sstream>
#include <string>
#include <type_traits>
#include <utility>
#include <vector>

#include <fmt/core.h>
#include <fmt/format.h>
#include <fmt/ranges.h>

#include <parameter_traits/parameter_traits.hpp>

#include <rsl/static_string.hpp>
#include <rsl/static_vector.hpp>
#include <rsl/parameter_validators.hpp>



namespace rosgraph_monitor {

// Use validators from RSL
using rsl::unique;
using rsl::subset_of;
using rsl::fixed_size;
using rsl::size_gt;
using rsl::size_lt;
using rsl::not_empty;
using rsl::element_bounds;
using rsl::lower_element_bounds;
using rsl::upper_element_bounds;
using rsl::bounds;
using rsl::lt;
using rsl::gt;
using rsl::lt_eq;
using rsl::gt_eq;
using rsl::one_of;
using rsl::to_parameter_result_msg;

// temporarily needed for backwards compatibility for custom validators
using namespace parameter_traits;

template <typename T>
[[nodiscard]] auto to_parameter_value(T value) {
    return rclcpp::ParameterValue(value);
}

template <size_t capacity>
[[nodiscard]] auto to_parameter_value(rsl::StaticString<capacity> const& value) {
    return rclcpp::ParameterValue(rsl::to_string(value));
}

template <typename T, size_t capacity>
[[nodiscard]] auto to_parameter_value(rsl::StaticVector<T, capacity> const& value) {
    return rclcpp::ParameterValue(rsl::to_vector(value));
}
    struct Params {
        int64_t diagnostics_publish_period_ms = 1000;
        struct GraphMonitor {
            std::string diagnostic_namespace = "Rosgraph";
            struct Nodes {
                std::vector<std::string> ignore_prefixes = {"/_ros2cli_", "/dummy", "/launch_ros_", "/transform_listener_impl_"};
                std::vector<std::string> warn_only_prefixes = {};
            } nodes;
            struct Continuity {
                bool enable = true;
                std::vector<std::string> ignore_subscriber_nodes = {"/rosbag2_recorder", "/foxglove_bridge"};
                std::vector<std::string> ignore_topic_types = {"foxglove_msgs/msg/ImageAnnotations", "foxglove_msgs/msg/SceneUpdate", "visualization_msgs/msg/Marker", "visualization_msgs/msg/MarkerArray"};
                std::vector<std::string> ignore_topic_names = {"/rosout"};
            } continuity;
            struct TopicStatistics {
                double deadline_allowed_error = 0.1;
                int64_t stale_timeout_ms = 3000;
            } topic_statistics;
        } graph_monitor;
        struct GraphAnalyzer {
            std::string diagnostic_prefix = "Rosgraph::";
            std::vector<std::string> mandatory_frequency_topics = {};
            std::vector<std::string> ignore_deadline_topics = {};
            bool all_nodes_required = true;
        } graph_analyzer;
        // for detecting if the parameter struct has been updated
        rclcpp::Time __stamp;
    };
    struct StackParams {
        int64_t diagnostics_publish_period_ms = 1000;
        struct GraphMonitor {
            struct Continuity {
                bool enable = true;
            } continuity;
            struct TopicStatistics {
                double deadline_allowed_error = 0.1;
                int64_t stale_timeout_ms = 3000;
            } topic_statistics;
        } graph_monitor;
        struct GraphAnalyzer {
            bool all_nodes_required = true;
        } graph_analyzer;
    };

  class ParamListener{
  public:
    // throws rclcpp::exceptions::InvalidParameterValueException on initialization if invalid parameter are loaded
    ParamListener(rclcpp::Node::SharedPtr node, std::string const& prefix = "")
    : ParamListener(node->get_node_parameters_interface(), node->get_logger(), prefix) {}

    ParamListener(rclcpp_lifecycle::LifecycleNode::SharedPtr node, std::string const& prefix = "")
    : ParamListener(node->get_node_parameters_interface(), node->get_logger(), prefix) {}

    ParamListener(const std::shared_ptr<rclcpp::node_interfaces::NodeParametersInterface>& parameters_interface,
                  std::string const& prefix = "")
    : ParamListener(parameters_interface, rclcpp::get_logger("rosgraph_monitor"), prefix) {
      RCLCPP_DEBUG(logger_, "ParameterListener: Not using node logger, recommend using other constructors to use a node logger");
    }

    ParamListener(const std::shared_ptr<rclcpp::node_interfaces::NodeParametersInterface>& parameters_interface,
                  rclcpp::Logger logger, std::string const& prefix = "")
    : prefix_{prefix},
      logger_{std::move(logger)} {
      if (!prefix_.empty() && prefix_.back() != '.') {
        prefix_ += ".";
      }

      parameters_interface_ = parameters_interface;
      declare_params();
      auto update_param_cb = [this](const std::vector<rclcpp::Parameter> &parameters){return this->update(parameters);};
      handle_ = parameters_interface_->add_on_set_parameters_callback(update_param_cb);
      clock_ = rclcpp::Clock();
    }

    Params get_params() const{
      std::lock_guard<std::mutex> lock(mutex_);
      return params_;
    }

    /**
     * @brief Tries to update the parsed Params object
     * @param params_in The Params object to update
     * @return true if the Params object was updated, false if it was already up to date or the mutex could not be locked
     * @note This function tries to lock the mutex without blocking, so it can be used in a RT loop
     */
    bool try_update_params(Params & params_in) const {
      std::unique_lock<std::mutex> lock(mutex_, std::try_to_lock);
      if (lock.owns_lock()) {
        if (const bool is_old = params_in.__stamp != params_.__stamp; is_old) {
          params_in = params_;
          return true;
        }
      }
      return false;
    }

    /**
     * @brief Tries to get the current Params object
     * @param params_in The Params object to fill with the current parameters
     * @return true if mutex can be locked, false if mutex could not be locked
     * @note The parameters are only filled, when the mutex can be locked and the params timestamp is different
     * @note This function tries to lock the mutex without blocking, so it can be used in a RT loop
     */
    bool try_get_params(Params & params_in) const {
      if (mutex_.try_lock()) {
        if (const bool is_old = params_in.__stamp != params_.__stamp; is_old) {
          params_in = params_;
        }
        mutex_.unlock();
        return true;
      }
      return false;
    }

    bool is_old(Params const& other) const {
      std::lock_guard<std::mutex> lock(mutex_);
      return params_.__stamp != other.__stamp;
    }

    StackParams get_stack_params() {
      Params params = get_params();
      StackParams output;
      output.diagnostics_publish_period_ms = params.diagnostics_publish_period_ms;
      output.graph_monitor.continuity.enable = params.graph_monitor.continuity.enable;
      output.graph_monitor.topic_statistics.deadline_allowed_error = params.graph_monitor.topic_statistics.deadline_allowed_error;
      output.graph_monitor.topic_statistics.stale_timeout_ms = params.graph_monitor.topic_statistics.stale_timeout_ms;
      output.graph_analyzer.all_nodes_required = params.graph_analyzer.all_nodes_required;

      return output;
    }

    void refresh_dynamic_parameters() {
      auto updated_params = get_params();
      // TODO remove any destroyed dynamic parameters

      // declare any new dynamic parameters
      rclcpp::Parameter param;

    }

    rcl_interfaces::msg::SetParametersResult update(const std::vector<rclcpp::Parameter> &parameters) {
      auto updated_params = get_params();

      for (const auto &param: parameters) {
        if (param.get_name() == (prefix_ + "diagnostics_publish_period_ms")) {
            updated_params.diagnostics_publish_period_ms = param.as_int();
            RCLCPP_DEBUG_STREAM(logger_, param.get_name() << ": " << param.get_type_name() << " = " << param.value_to_string());
        }
        if (param.get_name() == (prefix_ + "graph_monitor.diagnostic_namespace")) {
            updated_params.graph_monitor.diagnostic_namespace = param.as_string();
            RCLCPP_DEBUG_STREAM(logger_, param.get_name() << ": " << param.get_type_name() << " = " << param.value_to_string());
        }
        if (param.get_name() == (prefix_ + "graph_monitor.nodes.ignore_prefixes")) {
            updated_params.graph_monitor.nodes.ignore_prefixes = param.as_string_array();
            RCLCPP_DEBUG_STREAM(logger_, param.get_name() << ": " << param.get_type_name() << " = " << param.value_to_string());
        }
        if (param.get_name() == (prefix_ + "graph_monitor.nodes.warn_only_prefixes")) {
            updated_params.graph_monitor.nodes.warn_only_prefixes = param.as_string_array();
            RCLCPP_DEBUG_STREAM(logger_, param.get_name() << ": " << param.get_type_name() << " = " << param.value_to_string());
        }
        if (param.get_name() == (prefix_ + "graph_monitor.continuity.enable")) {
            updated_params.graph_monitor.continuity.enable = param.as_bool();
            RCLCPP_DEBUG_STREAM(logger_, param.get_name() << ": " << param.get_type_name() << " = " << param.value_to_string());
        }
        if (param.get_name() == (prefix_ + "graph_monitor.continuity.ignore_subscriber_nodes")) {
            updated_params.graph_monitor.continuity.ignore_subscriber_nodes = param.as_string_array();
            RCLCPP_DEBUG_STREAM(logger_, param.get_name() << ": " << param.get_type_name() << " = " << param.value_to_string());
        }
        if (param.get_name() == (prefix_ + "graph_monitor.continuity.ignore_topic_types")) {
            updated_params.graph_monitor.continuity.ignore_topic_types = param.as_string_array();
            RCLCPP_DEBUG_STREAM(logger_, param.get_name() << ": " << param.get_type_name() << " = " << param.value_to_string());
        }
        if (param.get_name() == (prefix_ + "graph_monitor.continuity.ignore_topic_names")) {
            updated_params.graph_monitor.continuity.ignore_topic_names = param.as_string_array();
            RCLCPP_DEBUG_STREAM(logger_, param.get_name() << ": " << param.get_type_name() << " = " << param.value_to_string());
        }
        if (param.get_name() == (prefix_ + "graph_monitor.topic_statistics.deadline_allowed_error")) {
            updated_params.graph_monitor.topic_statistics.deadline_allowed_error = param.as_double();
            RCLCPP_DEBUG_STREAM(logger_, param.get_name() << ": " << param.get_type_name() << " = " << param.value_to_string());
        }
        if (param.get_name() == (prefix_ + "graph_monitor.topic_statistics.stale_timeout_ms")) {
            updated_params.graph_monitor.topic_statistics.stale_timeout_ms = param.as_int();
            RCLCPP_DEBUG_STREAM(logger_, param.get_name() << ": " << param.get_type_name() << " = " << param.value_to_string());
        }
        if (param.get_name() == (prefix_ + "graph_analyzer.diagnostic_prefix")) {
            updated_params.graph_analyzer.diagnostic_prefix = param.as_string();
            RCLCPP_DEBUG_STREAM(logger_, param.get_name() << ": " << param.get_type_name() << " = " << param.value_to_string());
        }
        if (param.get_name() == (prefix_ + "graph_analyzer.mandatory_frequency_topics")) {
            updated_params.graph_analyzer.mandatory_frequency_topics = param.as_string_array();
            RCLCPP_DEBUG_STREAM(logger_, param.get_name() << ": " << param.get_type_name() << " = " << param.value_to_string());
        }
        if (param.get_name() == (prefix_ + "graph_analyzer.ignore_deadline_topics")) {
            updated_params.graph_analyzer.ignore_deadline_topics = param.as_string_array();
            RCLCPP_DEBUG_STREAM(logger_, param.get_name() << ": " << param.get_type_name() << " = " << param.value_to_string());
        }
        if (param.get_name() == (prefix_ + "graph_analyzer.all_nodes_required")) {
            updated_params.graph_analyzer.all_nodes_required = param.as_bool();
            RCLCPP_DEBUG_STREAM(logger_, param.get_name() << ": " << param.get_type_name() << " = " << param.value_to_string());
        }
      }

      updated_params.__stamp = clock_.now();
      update_internal_params(updated_params);
      if (user_callback_) {
         user_callback_(updated_params);
      }
      return rsl::to_parameter_result_msg({});
    }

    void declare_params(){
      auto updated_params = get_params();
      // declare all parameters and give default values to non-required ones
      if (!parameters_interface_->has_parameter(prefix_ + "diagnostics_publish_period_ms")) {
          rcl_interfaces::msg::ParameterDescriptor descriptor;
          descriptor.description = "Period in milliseconds between each publishing of the graph diagnostics.";
          descriptor.read_only = true;
          auto parameter = to_parameter_value(updated_params.diagnostics_publish_period_ms);
          parameters_interface_->declare_parameter(prefix_ + "diagnostics_publish_period_ms", parameter, descriptor);
      }
      if (!parameters_interface_->has_parameter(prefix_ + "graph_monitor.diagnostic_namespace")) {
          rcl_interfaces::msg::ParameterDescriptor descriptor;
          descriptor.description = "Namespace to put up front of generated diagnostics";
          descriptor.read_only = false;
          auto parameter = to_parameter_value(updated_params.graph_monitor.diagnostic_namespace);
          parameters_interface_->declare_parameter(prefix_ + "graph_monitor.diagnostic_namespace", parameter, descriptor);
      }
      if (!parameters_interface_->has_parameter(prefix_ + "graph_monitor.nodes.ignore_prefixes")) {
          rcl_interfaces::msg::ParameterDescriptor descriptor;
          descriptor.description = "If node FQN starts with any of these prefixes, ignore completely for graph analysis";
          descriptor.read_only = false;
          auto parameter = to_parameter_value(updated_params.graph_monitor.nodes.ignore_prefixes);
          parameters_interface_->declare_parameter(prefix_ + "graph_monitor.nodes.ignore_prefixes", parameter, descriptor);
      }
      if (!parameters_interface_->has_parameter(prefix_ + "graph_monitor.nodes.warn_only_prefixes")) {
          rcl_interfaces::msg::ParameterDescriptor descriptor;
          descriptor.description = "If node FQN starts with any of these prefixes, downgrade ERROR to WARN when missing";
          descriptor.read_only = false;
          auto parameter = to_parameter_value(updated_params.graph_monitor.nodes.warn_only_prefixes);
          parameters_interface_->declare_parameter(prefix_ + "graph_monitor.nodes.warn_only_prefixes", parameter, descriptor);
      }
      if (!parameters_interface_->has_parameter(prefix_ + "graph_monitor.continuity.enable")) {
          rcl_interfaces::msg::ParameterDescriptor descriptor;
          descriptor.description = "Set to false to disable continuity checking (maybe you have a ton of debug topics?)";
          descriptor.read_only = false;
          auto parameter = to_parameter_value(updated_params.graph_monitor.continuity.enable);
          parameters_interface_->declare_parameter(prefix_ + "graph_monitor.continuity.enable", parameter, descriptor);
      }
      if (!parameters_interface_->has_parameter(prefix_ + "graph_monitor.continuity.ignore_subscriber_nodes")) {
          rcl_interfaces::msg::ParameterDescriptor descriptor;
          descriptor.description = "For continuity checking, pretend these nodes are not subscribing to any topics";
          descriptor.read_only = false;
          auto parameter = to_parameter_value(updated_params.graph_monitor.continuity.ignore_subscriber_nodes);
          parameters_interface_->declare_parameter(prefix_ + "graph_monitor.continuity.ignore_subscriber_nodes", parameter, descriptor);
      }
      if (!parameters_interface_->has_parameter(prefix_ + "graph_monitor.continuity.ignore_topic_types")) {
          rcl_interfaces::msg::ParameterDescriptor descriptor;
          descriptor.description = "Never report discontinuities on topics with these types - useful for viz/debug messages";
          descriptor.read_only = false;
          auto parameter = to_parameter_value(updated_params.graph_monitor.continuity.ignore_topic_types);
          parameters_interface_->declare_parameter(prefix_ + "graph_monitor.continuity.ignore_topic_types", parameter, descriptor);
      }
      if (!parameters_interface_->has_parameter(prefix_ + "graph_monitor.continuity.ignore_topic_names")) {
          rcl_interfaces::msg::ParameterDescriptor descriptor;
          descriptor.description = "Never report discontinuities on topics with these exact names";
          descriptor.read_only = false;
          auto parameter = to_parameter_value(updated_params.graph_monitor.continuity.ignore_topic_names);
          parameters_interface_->declare_parameter(prefix_ + "graph_monitor.continuity.ignore_topic_names", parameter, descriptor);
      }
      if (!parameters_interface_->has_parameter(prefix_ + "graph_monitor.topic_statistics.deadline_allowed_error")) {
          rcl_interfaces::msg::ParameterDescriptor descriptor;
          descriptor.description = "Multiplier for the deadline period, if period falls within this error bound it is considered correct";
          descriptor.read_only = false;
          auto parameter = to_parameter_value(updated_params.graph_monitor.topic_statistics.deadline_allowed_error);
          parameters_interface_->declare_parameter(prefix_ + "graph_monitor.topic_statistics.deadline_allowed_error", parameter, descriptor);
      }
      if (!parameters_interface_->has_parameter(prefix_ + "graph_monitor.topic_statistics.stale_timeout_ms")) {
          rcl_interfaces::msg::ParameterDescriptor descriptor;
          descriptor.description = "Maximum period to receive updated statistics for a topic before an error is raised that it is missing";
          descriptor.read_only = false;
          auto parameter = to_parameter_value(updated_params.graph_monitor.topic_statistics.stale_timeout_ms);
          parameters_interface_->declare_parameter(prefix_ + "graph_monitor.topic_statistics.stale_timeout_ms", parameter, descriptor);
      }
      if (!parameters_interface_->has_parameter(prefix_ + "graph_analyzer.diagnostic_prefix")) {
          rcl_interfaces::msg::ParameterDescriptor descriptor;
          descriptor.description = "Prefix on diagnostics to match";
          descriptor.read_only = true;
          auto parameter = to_parameter_value(updated_params.graph_analyzer.diagnostic_prefix);
          parameters_interface_->declare_parameter(prefix_ + "graph_analyzer.diagnostic_prefix", parameter, descriptor);
      }
      if (!parameters_interface_->has_parameter(prefix_ + "graph_analyzer.mandatory_frequency_topics")) {
          rcl_interfaces::msg::ParameterDescriptor descriptor;
          descriptor.description = "Pre-seeds list of topics that must exist, have deadlines, and meet them. Note all other discovered deadline topics are still tracked.";
          descriptor.read_only = false;
          auto parameter = to_parameter_value(updated_params.graph_analyzer.mandatory_frequency_topics);
          parameters_interface_->declare_parameter(prefix_ + "graph_analyzer.mandatory_frequency_topics", parameter, descriptor);
      }
      if (!parameters_interface_->has_parameter(prefix_ + "graph_analyzer.ignore_deadline_topics")) {
          rcl_interfaces::msg::ParameterDescriptor descriptor;
          descriptor.description = "Topics with a deadline whose frequency should not be considered for health outcomes (escape hatch for known bad design/implementation)";
          descriptor.read_only = false;
          auto parameter = to_parameter_value(updated_params.graph_analyzer.ignore_deadline_topics);
          parameters_interface_->declare_parameter(prefix_ + "graph_analyzer.ignore_deadline_topics", parameter, descriptor);
      }
      if (!parameters_interface_->has_parameter(prefix_ + "graph_analyzer.all_nodes_required")) {
          rcl_interfaces::msg::ParameterDescriptor descriptor;
          descriptor.description = "Whether it should be considered an error for any node to be reported as missing from the monitor";
          descriptor.read_only = false;
          auto parameter = to_parameter_value(updated_params.graph_analyzer.all_nodes_required);
          parameters_interface_->declare_parameter(prefix_ + "graph_analyzer.all_nodes_required", parameter, descriptor);
      }
      // get parameters and fill struct fields
      rclcpp::Parameter param;
      param = parameters_interface_->get_parameter(prefix_ + "diagnostics_publish_period_ms");
      RCLCPP_DEBUG_STREAM(logger_, param.get_name() << ": " << param.get_type_name() << " = " << param.value_to_string());
      updated_params.diagnostics_publish_period_ms = param.as_int();
      param = parameters_interface_->get_parameter(prefix_ + "graph_monitor.diagnostic_namespace");
      RCLCPP_DEBUG_STREAM(logger_, param.get_name() << ": " << param.get_type_name() << " = " << param.value_to_string());
      updated_params.graph_monitor.diagnostic_namespace = param.as_string();
      param = parameters_interface_->get_parameter(prefix_ + "graph_monitor.nodes.ignore_prefixes");
      RCLCPP_DEBUG_STREAM(logger_, param.get_name() << ": " << param.get_type_name() << " = " << param.value_to_string());
      updated_params.graph_monitor.nodes.ignore_prefixes = param.as_string_array();
      param = parameters_interface_->get_parameter(prefix_ + "graph_monitor.nodes.warn_only_prefixes");
      RCLCPP_DEBUG_STREAM(logger_, param.get_name() << ": " << param.get_type_name() << " = " << param.value_to_string());
      updated_params.graph_monitor.nodes.warn_only_prefixes = param.as_string_array();
      param = parameters_interface_->get_parameter(prefix_ + "graph_monitor.continuity.enable");
      RCLCPP_DEBUG_STREAM(logger_, param.get_name() << ": " << param.get_type_name() << " = " << param.value_to_string());
      updated_params.graph_monitor.continuity.enable = param.as_bool();
      param = parameters_interface_->get_parameter(prefix_ + "graph_monitor.continuity.ignore_subscriber_nodes");
      RCLCPP_DEBUG_STREAM(logger_, param.get_name() << ": " << param.get_type_name() << " = " << param.value_to_string());
      updated_params.graph_monitor.continuity.ignore_subscriber_nodes = param.as_string_array();
      param = parameters_interface_->get_parameter(prefix_ + "graph_monitor.continuity.ignore_topic_types");
      RCLCPP_DEBUG_STREAM(logger_, param.get_name() << ": " << param.get_type_name() << " = " << param.value_to_string());
      updated_params.graph_monitor.continuity.ignore_topic_types = param.as_string_array();
      param = parameters_interface_->get_parameter(prefix_ + "graph_monitor.continuity.ignore_topic_names");
      RCLCPP_DEBUG_STREAM(logger_, param.get_name() << ": " << param.get_type_name() << " = " << param.value_to_string());
      updated_params.graph_monitor.continuity.ignore_topic_names = param.as_string_array();
      param = parameters_interface_->get_parameter(prefix_ + "graph_monitor.topic_statistics.deadline_allowed_error");
      RCLCPP_DEBUG_STREAM(logger_, param.get_name() << ": " << param.get_type_name() << " = " << param.value_to_string());
      updated_params.graph_monitor.topic_statistics.deadline_allowed_error = param.as_double();
      param = parameters_interface_->get_parameter(prefix_ + "graph_monitor.topic_statistics.stale_timeout_ms");
      RCLCPP_DEBUG_STREAM(logger_, param.get_name() << ": " << param.get_type_name() << " = " << param.value_to_string());
      updated_params.graph_monitor.topic_statistics.stale_timeout_ms = param.as_int();
      param = parameters_interface_->get_parameter(prefix_ + "graph_analyzer.diagnostic_prefix");
      RCLCPP_DEBUG_STREAM(logger_, param.get_name() << ": " << param.get_type_name() << " = " << param.value_to_string());
      updated_params.graph_analyzer.diagnostic_prefix = param.as_string();
      param = parameters_interface_->get_parameter(prefix_ + "graph_analyzer.mandatory_frequency_topics");
      RCLCPP_DEBUG_STREAM(logger_, param.get_name() << ": " << param.get_type_name() << " = " << param.value_to_string());
      updated_params.graph_analyzer.mandatory_frequency_topics = param.as_string_array();
      param = parameters_interface_->get_parameter(prefix_ + "graph_analyzer.ignore_deadline_topics");
      RCLCPP_DEBUG_STREAM(logger_, param.get_name() << ": " << param.get_type_name() << " = " << param.value_to_string());
      updated_params.graph_analyzer.ignore_deadline_topics = param.as_string_array();
      param = parameters_interface_->get_parameter(prefix_ + "graph_analyzer.all_nodes_required");
      RCLCPP_DEBUG_STREAM(logger_, param.get_name() << ": " << param.get_type_name() << " = " << param.value_to_string());
      updated_params.graph_analyzer.all_nodes_required = param.as_bool();


      updated_params.__stamp = clock_.now();
      update_internal_params(updated_params);
    }

    using userParameterUpdateCB = std::function<void(const Params&)>;
    void setUserCallback(const userParameterUpdateCB& callback){
      user_callback_ = callback;
    }

    void clearUserCallback(){
      user_callback_ = {};
    }

    private:
      void update_internal_params(Params updated_params) {
        std::lock_guard<std::mutex> lock(mutex_);
        params_ = std::move(updated_params);
      }

      std::string prefix_;
      Params params_;
      rclcpp::Clock clock_;
      std::shared_ptr<rclcpp::node_interfaces::OnSetParametersCallbackHandle> handle_;
      std::shared_ptr<rclcpp::node_interfaces::NodeParametersInterface> parameters_interface_;
      userParameterUpdateCB user_callback_;

      rclcpp::Logger logger_;
      std::mutex mutable mutex_;
  };

} // namespace rosgraph_monitor
